package types

type DiscoveryMessageType int

const (
	DiscoveryMessageTypeNone DiscoveryMessageType = iota
	DiscoveryMessageTypeQueueing
	DiscoveryMessageTypeFailedQueueing
	DiscoveryMessageTypeTimeout
	DiscoveryMessageTypeStart
	DiscoveryMessageTypeStop
	DiscoveryMessageTypeError
	DiscoveryMessageTypeHost
	DiscoveryMessageTypePort
	DiscoveryMessageTypeService
)

type DiscoveryMessage interface {
	Request() DiscoveryRequest
	Type() DiscoveryMessageType
	Result() interface{}
	Error() error
	Release()
}

type DiscoveryRequestType int

const (
	DiscoveryRequestTypeNone DiscoveryRequestType = iota
	DiscoveryRequestTypeHost
	DiscoveryRequestTypePort
	DiscoveryRequestTypeService
)

type DiscoveryRequest interface {
	RequesterID() string
	RequestType() DiscoveryRequestType
	Params() []interface{}

	SendMessage(messageType DiscoveryMessageType, data interface{}, err error)
}
